---
layout: job_family_page
title: Fullstack Engineer - Marketing
---

Fullstack Engineers on the Marketing team work on our marketing site: about.GitLab.com and gitlab.com. They work closely with product marketing, content marketing, and other members of the Marketing team. They are a part of the [Digital Experience team](/handbook/marketing/digital-experience/), and report to the [Director, Digital Experience](/job-families/marketing/digital-experience/#director-of-digital-experience).
 
## Responsibilities
* Work with the Marketing Strategy and Platforms team and other stakeholders (Content, DemandGen, Brand, etc.) to iterate on new features and improvements to GitLab's digital marketing platform.
* Consistently ship small features and improvements to our [Slippers design system](https://gitlab.com/gitlab-com/marketing/digital-experience/slippers-ui)
* Help improve the overall experience of our Marketing website through improving the quality of our codebases.
* Help identify areas of improvements in the code base that help contribute to make it better.
* Help plan sprints and complete prioritized issues from the issue tracker.
 
## Requirements
* Knowledge of HTML, CSS, HAML and JavaScript (jQuery, Vue.js).
* Experience with responsive design and best practices.
* Knowledge of current web accessibility standards and requirements.
* Knowledge of information architecture, interaction design, and user-centered design.
* Strong knowledge in core web and browser concepts (eg. how the browser parses and constructs a web page).
* Experience with performance and optimization problems and a demonstrated ability to both diagnose and prevent these problems.
* Experience using design software to collaborate with designers and create pixel perfect web pages (eg. Figma, Sketch).
* Experience with Git in a professional/workplace environment, ideally using the GitLab product as a user or contributor.
* The ability to work in an agile, [iterative](/handbook/values/#iteration) development process and embrace feedback from many perspectives.
* Proficiency in the English language, with the capacity to communicate complex technical problems, provide clear status updates, and [achieve consensus with peers](/handbook/values/#collaboration).
* [Self-motivated and self-managing](/handbook/values/#efficiency), with great organizational skills and a positive, solution-oriented mindset.
* An interest in [our values](/handbook/values/), and working in accordance with those values.
* Prefer experience with JAMstack, Ruby, and Middleman (and/or other static site generators).
* Prefer SaaS Product company experience.
* Prefer experience working with a global or otherwise multicultural team.
* Prefer understanding of marketing concepts such as conversion, analytics, A/B testing, lead generation, buyer journeys, and search engine optimization.

## Levels

### Fullstack Engineer (Intermediate) 

The Fullstack Engineer (Intermediate) reports to the [Director, Digital Experience](/job-families/marketing/digital-experience/#director-of-digital-experience).

#### Fullstack Engineer (Intermediate) Job Grade

The Fullstack Engineer (Intermediate) is a [grade 6](/handbook/total-rewards/compensation/compensation-calculator/#gitlab-job-grades).

#### Fullstack Engineer (Intermediate) Responsibilities

* Implement frameworks, code style guides, and templates to empower everyone to contribute.
* Implement site speed improvements and technical SEO.
* Support the architecture and engineering (HTML, CSS, JS, Ruby, Middleman, Haml) of about.gitlab.com.
* Assist in building and maintaining our Content Management System.
* Run the marketing website as an open source project, optimizing for maximum contributions to both code and content.

#### Fullstack Engineer (Intermediate) Requirements

* 3-5 years experience specializing in full stack development, website and web applications.
* Expert knowledge of HTML, CSS, HAML and JavaScript (jQuery, Vue.js).
* Understanding of responsive design and best practices.
* The ability to iterate quickly and embrace feedback from many perspectives.
* Knowledge of information architecture, interaction design, and user-centered design.
* Knowledge of Git and comfortability using the command line.
* Experience with Jamstack, Ruby, and Middleman (and/or other static site generators).
* Ability to use GitLab.
* Previous experience with Static Site Generators like Middleman, Jekyll, Hugo, etc., preferred. 
* Experience working in a fully or partially remote company, preferred. 
* A positive outlook on changing priorities, preferred. 
* The ability to proactively question and improve priorities, preferred.
* Marketing engineers should be familiar with marketing concepts such as conversion, analytics, A/B testing, lead generation, buyer journeys, and search engine optimization.

### Senior Fullstack Engineer

The Senior Fullstack Engineer reports to the [Director, Digital Experience](/job-families/marketing/digital-experience/#director-of-digital-experience).

#### Senior Fullstack Engineer Job Grade

The Senior Fullstack Engineer is a [grade 7](/handbook/total-rewards/compensation/compensation-calculator/#gitlab-job-grades). 

#### Senior Fullstack Engineer Responsibilities

* Extends the Fullstack Engineer (Intermediate) responsibilities.
* Lead the architecture and engineering of about.gitlab.com. 
* Research and define frameworks, code style guides, and templates to empower everyone to contribute.
* Work with cross functional partners, as a team leader. 
* Critical decision making, and knowing what will have the greatest business impact when prioritizing. 
* Own CI automation using GitLab to build, test, and deploy.
* Sharing knowledge and educating on best practices and new technologies.

#### Senior Fullstack Engineer Requirements

* Extends that of the Fullstack Engineer (Intermediate) requirements.
* 6+ years experience specializing in fullstack development, website and web applications.
* Uses research, data, and best practices to create, validate, and present ideas to key
stakeholders.
* A track record of being self-motivated, results oriented, and delivering on time.
* Expert in selecting and applying frameworks/systems to solve complicated technical problems. 
* The ability to communicate complex ideas and solutions to non-technical stakeholders. 

### Manager, Engineering

The Manager, Engineering reports the the [Director, Digital Experience](/job-families/marketing/digital-experience/#director-of-digital-experience).
 
#### Manager, Engineering Job Grade
The Manager, Engineering is a [grade 8](/handbook/total-rewards/compensation/compensation-calculator/#gitlab-job-grades).  
 
#### Manager, Engineering Responsibilities
* Seek to build out a great team
* Make your team happy and successful
* Improve processes to make your team more effective
* Hold regular 1:1's with all members of your team
* Plan and execute long term strategies that benefit the team and the Marketing Site
* Conduct code reviews, and make technical contributions to Marketing Site architecture
* Get involved in solving bugs and delivering small features
* Foster technical decision making on the team, and make final decisions when necessary
* Discern engineering metrics and seek to improve them
 
#### Manager, Engineering Requirements
* Collaborate effectively with others
* Ability to achieve consensus amongst stakeholders
* 5 years or more experience related to the responsibilities listed above.
* 2 years or more experience in a leadership role with current technical experience
* You have an expert comprehension of core web and browser concepts (eg. how does JavaScript handle asynchronous code)
* You have in-depth experience with CSS, HTML, JavaScript, and Modern Web Development
* You have excellent written and verbal communication skills
* Our [values](/handbook/values/) of collaboration, results, efficiency, diversity, iteration, and transparency resonate with you
* Ability to use GitLab

## Performance Indicators

## Performance Indicators
* [Contributing to the success of Digital Experience's Quarterly Initiatives](/handbook/marketing/digital-experience/#okrs)
* [Identifying and organizing epics into executable Sprint plans](/handbook/marketing/digital-experience/#sprint-planning)
* [Successfully completing bi-weekly Sprint tasks](/handbook/marketing/digital-experience/#sprint-cycle)

## Career Ladder

The next step in the Website Full Stack Development job family is not yet defined at GitLab. 

## Hiring Process

Candidates for this position can expect the hiring process to follow the order below. Please keep in mind that candidates can be declined from the position at any stage of the process. To learn more about someone who may be conducting the interview, you can find their job title on our [team page](/company/team/).

* Select candidates will be invited to schedule a 30 minute [screening call](/handbook/hiring/#screening-call) with one of our Global Recruiters.
* Next, candidates will be invited to schedule a 30 minute interview with our Director, Digital Experience. 
* Next, candidates will be invited to schedule a 30 minute technical interview with our Fullstack Engineer and an interview with a Senior Brand Designer. 
* Next, candidates will be invited to schedule a 30 minute interview with the Senior Director, Growth Marketing. 
* Finally, candidates will be invited to schedule a 30 minute follow up interview with the Director, Digital Experience. 
* Successful candidates will subsequently be made an offer via phone or video. 

Additional details about our process can be found on our [hiring page](/handbook/hiring/).
